Type TParticle Extends Entity
	Field life#, lifetime#
	Field angle
	Field turnspeed
	Field color
	Field size:Float
	Field scale:Float
	Field friction:Float
	Field style
	Field big
	
	Method Update()
		xs = xs * friction
		ys = ys * friction
		x = x + xs
		y = y + ys	
		angle = angle + turnspeed
		life = life - 1
		size = size * scale
		If life < 1 Then Particlelist.Remove(Self)
	EndMethod
	
	Method Render() 
		Select color
			Case 0	' valkoiset
				SetColor 255 -guide_r,255 -guide_b, 255-guide_b
			Case 1	' punaiset
				SetColor  255 -guide_r,255 -guide_b, 255-guide_b
				
		EndSelect
		If big = 1 Then SetColor 255,255,255
		SetScale size, size
		SetRotation angle
		SetAlpha life / lifetime
		Select style
		Case 0
			DrawImage imgParticle , x , y
		Case 1
			DrawImage imgParticle2 , x , y
		EndSelect
	EndMethod
	
	Function Create:TParticle(_x , _y , _xs, _ys, _color = 0, _style=0, _big=0)
		Local p:TParticle = New TParticle
		p.x = _x
		p.y = _y
		p.xs = _xs
		p.ys = _ys
		p.style = _style
		p.color = _color
		p.scale = Rnd(0.99 , 1.01)
		p.size = 1.0
		p.lifetime = Rand(10 , 60)
		p.life = p.lifetime
		p.big = 0
		If _big = 1 Then
			p.size = 9
			p.scale = 0.90
			p.lifetime = 20
			p.life = p.lifetime
			p.big = 1
		
		EndIf
		Particlelist.AddLast(p)
	EndFunction
	
	Method New()	
		turnspeed = Rnd( - 5 , 5) 
		'lifetime = Rand(10, 60)
		life = lifetime
		'scale = 
		friction = 0.99
	EndMethod
	
EndType
	
