Strict 
Const WIDTH = 800
Const HEIGHT = 600

Global time
Global start
Global zoomin:Float
Global everyone_stop

Global imgPlayer:TImage
Global imgVihu:TImage
Global imgBullet:TImage

Global bpm
Global ChnMusic:TChannel
AppTitle = "mindeeper"
Graphics WIDTH, HEIGHT
SetBlend ALPHABLEND
AutoMidHandle True

Type TFrame
	Field size:Float	'from 0.0 to 1.0
	Field zoomspeed:Float
	Field img:TImage
	Field getbig 't menee sitten ihan tositosi isoksi
	Field countdown:Float 'loppua kohden tt sitten lasketaan
	Field seed:Int
	Field fadespeed:Float
	Field life
	Field state
	
	Method Update(zoom:Float)
		zoomspeed = zoom
		life = life - 1
		If size > 1.0  Then
			If state = 0 Then everyone_stop = True
			state = 1
			If everyone_stop = False Then
				size = size + zoomspeed
			EndIf
		Else
			size = size + zoomspeed
			everyone_stop = False
		EndIf
		
		If state = 2 Then
			If everyone_stop = False Then 
				size = size + zoomspeed*5
				countdown = countdown - fadespeed
			EndIf
		EndIf
	EndMethod

	Method Render(cam_x:Int , cam_y:Int) 
		SeedRnd seed
			If life < 50 Then
				SetAlpha life / 50.0
			Else
				SetAlpha 1
			EndIf
			
			'Local c = GetColor(0,0,0)
			
			SetRotation Sin(time / 16) * 10 + (beat^2)
			SetScale size , size
			Local i
			Local x# , y# , w# , h#
			Local plus# = ((beat^2) * -32)
			Local r:Float , g:Float , b:Float
			For i = 0 To Rand(0 , 15)
				r = Rnd(0.7 , 1) 
				g = Rnd(0.6 , 1) 
				b = Rnd(0.6, 1)
				SetColor guide_r*r+plus, guide_g*g+plus, guide_b*b+plus
				x# = Rand(-WIDTH/2 , WIDTH) - beat * 5  + hitflash_counter*10
				y# = Rand(-HEIGHT/2 , HEIGHT) - beat* 5- hitflash_counter*10
				w# = Rand(100 , WIDTH) + beat* 5
				h# = Rand(100 , HEIGHT) + beat* 5
				DrawRect size*x -400*size + 400, size*y - 300*size + 300, w, h
			Next
			If Rand(0 , 2) = 0 Then	'eye
				SetAlpha ((beat) * Abs(Sin((Rnd(0,90))+(time / 22.0))))*0.2
				SetScale 1+ Cos( time / 85)*0.5 , 1 + Sin( time /96) * 0.5
				SetRotation time/180.0 + Rnd(-500,800)
				SetColor 255 , 255 , 255
				DrawImage imgEye, 400+ Cos((Rnd(0,100)+(time/180.0)))*300.0, 300 + Sin( time / 169.0) * 200.0
				'DrawImage imgEye , 400 + Cos( (Rand(0,9000) + (time / 180.0)) * 300.0 , 300 + Sin( time / 165.0) * 200)
				SetAlpha 1
			EndIf
			'For i = 1 To 0
			For i = 1 To Rand(0 , 3) 	'sienet
				SetAlpha Abs(Sin((Rnd(0,90)) + (time / 42+i*100.0)) ) *0.2
				Local x# = 1+ Cos( time / 85)*0.5 + beat*0.01
				SetScale  x, x
				SetRotation time/74.0 + (i * 20+Rand(0,900))
				SetColor 255,255,255
				DrawImage imgMushroom , 400 + Cos( (Rand(0,9000)) + (time / 280.0 + i*90)) * 500.0 , 300 + Sin( (Rand(0,9000)) + (time / 220.0 + i*45)) * 220
				SetAlpha 1
			Next 
				
			'DrawRect -(WIDTH/2)*size + 100 + Sin(time / 10)*10,-(HEIGHT/2)*size+ 100, 200, 200
			SeedRnd time 'back to normal seed
	EndMethod
	
	Function Create:TFrame() 
		Local c:TFrame = New TFrame
		c.img = CreateImage(640 , 480 , 1 , DYNAMICIMAGE | MASKEDIMAGE) 
		'GrabImage c.img , 0 , 0
		c.size = 0.0
		c.zoomspeed = 0.01
		c.getbig = False
		c.life = 1200
		c.countdown = c.life
		c.fadespeed = 2
		SeedRnd time
		c.state = 0	'eka STATE
		c.seed = Rand(0 , 32100) 
		SetClsColor guide_r*0.5, guide_g*0.5, guide_b*0.5
		
		Return c
	EndFunction
EndType

Type Entity
	Field x# , y#
	Field xs# , ys#
	Field angle#
EndType

Include "vihu.bmx"
Include "TPlayer.bmx"
Include "TBullet.bmx"
Include "TParticle.bmx"

Local image:TImage=CreateImage(640,480,1,DYNAMICIMAGE|MASKEDIMAGE)
'GrabImage image , 0 , 0

Global Framelist:TList = New TList
Global Vihulist:TList
Global Playerlist:TList
Global Bulletlist:TList
Global Particlelist:TList = New TList

Global oldmousex
Global mousemovex
Global mousextotal

' pelin muuttujia
Global spawn_interval
Global spawn_amount
Global spawn_counter

' pelaajan muuttujia
Global GlobalHealth, score
Global playerx, playery
Global kills , level

Global start_cooldown
Global flash_counter:Float
Global hitflash_counter:Float

Global game_ended	'if this is true, enemies won't shoot at you and countdown starts

Global guide_r, guide_g, guide_b	' vriarvot joita noudattaen taustat luodaan


bpm = 130
Global interval:Float = 60000.0 / bpm
Global tahdit, tahdit2, old_tahdit	'oldia kytetn tunnistamaan jos tahti on vaihtunut
Global tahti_changed
Global beat:Float	' vlill 0.0 - 1.0
Global time_phase = 0
Global vihu_shoot_sound_play

Global note

Global imgShade:TImage = LoadImage("gfx\shade2.png")
Global imgPlayerFrame1:TImage = LoadImage("gfx\player1.png")
Global imgPlayerFrame2:TImage = LoadImage("gfx\player2.png")
Global imgPlayerWeapon:TImage = LoadImage("gfx\weapon.png")
'imgVihu = LoadImage("gfx\vihu.png")
Global imgVihuFrame1:TImage = LoadImage("gfx\vihu1.png")
Global imgVihuFrame2:TImage = LoadImage("gfx\vihu2.png") 
imgBullet = LoadImage("gfx\bullet.png") 
Global imgParticle:TImage = LoadImage("gfx\particle.png") 
Global imgVihuBullet:TImage = LoadImage("gfx\vihuammus.png") 
Global imgParticle2:TImage = LoadImage("gfx\particle2.png") 
Global imgHelp:TImage = LoadImage("gfx\help.png") 
Global imgShadow:TImage = LoadImage("gfx\shadow.png") 
Global imgAim:TImage = LoadImage("gfx\aim.png") 
Global imgEye:TImage = LoadImage("gfx\eye.png") 
Global imgMushroom:TImage = LoadImage("gfx\mushroom.png")

Global Font1:TImagefont = LoadImageFont( "VeraMono.ttf", 16, SMOOTHFONT)
If Font1 = Null Then Notify "Font Not Loaded"

Global Font2:TImagefont = LoadImageFont( "VeraMono.ttf", 32, SMOOTHFONT)
If Font2 = Null Then Notify "Font Not Loaded"

Global Font3:TImagefont = LoadImageFont( "VeraMono.ttf", 52, SMOOTHFONT)
If Font3 = Null Then Notify "Font Not Loaded"

Global sndA:TSound = LoadSound("sfx\a.ogg")
Global sndD:TSound = LoadSound("sfx\g.ogg") 
Global sndG:TSound = LoadSound("sfx\d.ogg") 
Global sndBoom:TSound = LoadSound("sfx\boom1.ogg") 
Global sndEnemyShoot:TSound = LoadSound("sfx\enemybullet.ogg") 
Global sndPlayerhit:TSound = LoadSound("sfx\playerhit.ogg") 
Global sndPlayershoot:TSound = LoadSound("sfx\playershoot.ogg") 
Global MusicChannel:TChannel = AllocChannel()
Global SndMusic:TSound = LoadSound("song3.ogg" , True)


everyone_stop = False
NewFrame() 
NewColorScheme() 
NewFrame() 
'valikko:D
Local alku = MilliSecs()
While Not KeyDown(KEY_ESCAPE)
	time = MilliSecs() - alku
	Cls
	
	If KeyHit(KEY_SPACE) Then
		DasGame()
		FlushKeys()
		PauseChannel MusicChannel
	EndIf
	
	If KeyHit(KEY_A) Then newFrame()
	
	UpdateFrames() 
	RenderFrames() 
	UpdateParticle() 
	RenderParticle()
	
	SetScale 1,1
	SetColor 255 , 255 , 255
	SetRotation 0
	SetAlpha 1
	DrawImage imgHelp , 400 , 400
	SetImageFont Font3
	SetRotation - 5 + Sin(time / 15) * 2
		SetColor 0 , 0 , 0
		
	SetScale 2 , 2
	SetColor 0,0,0
	SetRotation 0
	SetAlpha 0.2
	DrawImage imgShade , 400 , 300
	SetScale 1 , 1
	SetAlpha 1

	DrawText "mindeeper", 150+2, 120+2
	SetColor 255 , 255 , 255
	DrawText "mindeeper", 150, 120
	SetImageFont Font2
	SetRotation 1+Sin(time/16)*1
	DrawText "press space to start the game!" , 100 , 500
	SetRotation 7
	DrawText "controls: ", 220,250
	SetImageFont Font1
	SetRotation 1 + Sin(time / 16) * 1
	SetColor 0 , 0 , 0
	DrawText "(and esc to quit)" , 502 , 552
	SetColor 128 , 128 , 128
	DrawText "(and esc to quit)" , 500 , 550

	Flip 1
Wend 
End


Function DasGame() 
game_ended = False
globalhealth = 500
ResetGame() 
FlushKeys() 

CueSound (SndMusic , MusicChannel)
ResumeChannel (MusicChannel)
'PlaySound SndMusic

start = MilliSecs()
While Not KeyDown(KEY_ESCAPE)
Cls
	mousemovex = oldmousex - MouseX() 
	oldmousex = MouseX() 
	mousextotal = mousextotal + MouseX() 'kytetn randomluvuissa
	time = (MilliSecs() - start + time_phase)
	tahdit = (time) / (interval * 16)	' peli etenee 16 tahdin ptkiss
	tahdit2 = (time) / (interval )	' peli etenee 16 tahdin ptkiss	
	beat = (Sin((Float(time Mod interval) / Float(interval)) * 360)+1)/2.0
	If (old_tahdit <> tahdit) Then
		tahti_changed = True
		' uusi kentt, uudet kujeet
		NewFrame() 
		ClearEnemies()
		ClearBullets()
		spawn_interval = 1000 - tahdit * 10
		If spawn_interval < 500 Then spawn_interval = 500
		If game_ended = False Then spawn_amount = 5 + tahdit
		spawn_counter = spawn_amount
		If game_ended = False Then level = level + 1	'yayy! deeper levelzz!
		flash_counter = 1.0
		NewColorScheme()
	EndIf
	
	old_tahdit = tahdit
	
	spawn_counter = spawn_counter - 1
	If spawn_counter < 0 Then
		Local i
		For i=0 To spawn_amount
			AddEnemy()
		Next 
		spawn_counter = spawn_interval
	EndIf 
	
	If KeyHit(KEY_SPACE) Then
		'NewFrame() 
		'ClearEnemies() 
		'ClearBullets() 
	EndIf
	
	If KeyHit(KEY_V) Then
		'AddEnemy()
	EndIf
	
	zoomin = 0.05
	
	UpdateFrames()
	UpdateEnemy() 
	UpdatePlayer() 
	UpdateBullet()
	UpdateParticle() 
	
	If vihu_shoot_sound_play = True Then
		PlaySoundBetter(sndEnemyShoot,1.0)
	EndIf
	vihu_shoot_sound_play = False
	
	RenderFrames() 
	RenderEnemy()
	RenderPlayer() 
	RenderParticle()
	RenderBullet()
	
	SetScale 2 , 2
	SetColor 0,0,0
	SetRotation 0
	SetAlpha ((beat^2) * 0.3)+0.2
	DrawImage imgShade, 400,300
	
	SetScale 1+ beat*0.02 , 1 + beat*0.02
	SetAlpha 1
	SetRotation 0
	SetImageFont Font1
	SetColor 255 , 255 , 255
	'
	'DrawText "everyone_stop : " + everyone_stop, 0, 0
	'DrawText "bpm: " + bpm + " interval: " + interval + " tahdit: " + tahdit + "tahdit2: "+tahdit2 , 0 , 12
	'DrawText "spawn interval: " + spawn_interval , 0 , 20
	'REMEND
	'DrawText "health: " + GlobalHealth + "beat: "+beat + " aika: "+time, 0, 35
	SetImageFont Font2
	SetColor 255 , 255 , 255
	SetRotation 10
	DrawText "KILLS: " + kills , 620-beat , 5-beat
	DrawText "LEVEL: " + level , 620-beat , 50-beat
	If GlobalHealth > 101 Then
		SetColor 255 , 255 , 255
	Else
		SetColor 255*(beat>0.5) , 0, 0
	EndIf
	SetRotation -10
	DrawText "HEALTH: " + GLobalHealth , 10 + (beat ^ 2) * 2 , 55
	
	SetScale 0.9+ beat*0.1 , 0.9 + beat*0.1
	SetAlpha 1
	SetRotation Sin(time / 24)*2
	SetColor 255 , 255 , 255
	DrawImage imgAim, MouseX(), MouseY()
	
	If game_ended = True Then
		RenderGameOver() 
		PauseChannel MusicChannel
		
		'If KeyHit(KEY_SPACE) Then
	'		Return kills
	'	EndIf
	EndIf
	
	
	
	start_cooldown = start_cooldown -1
	flash_counter = Max(flash_counter - 0.1 , 0)
	 hitflash_counter = Max(hitflash_counter - 0.1 , 0) 
	SetScale 1,1
	SetAlpha flash_counter
	SetColor 255 , 255 , 255
	SetRotation 0
	DrawRect 0 , 0 , 800 , 600
	
	SetAlpha hitflash_counter
	SetColor 255 , 0 , 0
	SetRotation 0
	DrawRect 0,0,800,600
Flip 1
Wend
EndFunction
End

Function RenderGameOver()
	SetImageFont Font2
	SetScale 2+ beat*0.1 , 2 + beat*0.1
	SetAlpha 1
	SetRotation 0 + Sin(time / 18)
	SetColor 255*(beat>0.5),0,0
	DrawText "GAME OVER" , 220-beat*2 , 250-beat
	
	SetScale 1 , 1
	SetColor 255,255,255
	SetRotation 0 + Sin(time / 28)
	DrawText "KILLS: "+kills, 230, 370
	
	SetScale 1 , 1
	SetAlpha 1
	SetRotation 0 
	SetColor 255,255,255

	DrawText "press esc to return to menu",180,460
EndFunction


' oiskohan nit funkkareita jo tarpeeks
Function NewColorScheme() 
	guide_r = Rand(255) 
	guide_g = Rand(255) 
	guide_b = Rand(255)
EndFunction

Function ResetGame() 
	Framelist = New TList	'garbage collector<3
	Vihulist = New TList
	Playerlist = New TList
	Bulletlist = New TList
	Particlelist = New TList
	
	Local c:TFrame = TFrame.Create()
	Framelist.AddLast(c)
	
	'pelaaja listn listaan automaattisesti
	Local p:TPlayer = New TPlayer
	
	start = MilliSecs() 
	spawn_interval = 1000
	spawn_amount = 5
	score = 0
	level = 0
	kills = 0
	start_cooldown = 400	'no shooting in these frames
	NewColorScheme()
	
EndFunction

Function ClearBullets() 
	Local c:TBullet
	For c=EachIn Bulletlist
		Bulletlist.remove(c) ' swuuh!
	Next 
EndFunction

Function ClearEnemies() 	'vanhat vihut lhtee huitelemaan
	Local c:Vihu
	For c=EachIn Vihulist
		c.MoveAway() ' swuuh!
		
	Next 
EndFunction

Function AddBullet(_x, _y, _angle, _owner = 0) 
	'Local c:TBullet = New TBullet(_x, _y)
	Local c:TBullet = TBullet.Create(_x, _y, _angle, _owner)
EndFunction

Function AddEnemy() 
	Local c:Vihu = New Vihu
EndFunction



Function NewFrame() 
	' poistetaan vanhat framet
	Local c:TFrame
	For c=EachIn Framelist
		c.getbig = True
		c.state = 2 'eli suurenee, 2 on lopetus
	Next
	'ja uus tulee tilalle

	Local cc:TFrame = TFrame.Create()
	Framelist.AddLast(cc)
EndFunction

Function UpdateParticle() 
	Local c:TParticle
	For c=EachIn Particlelist
		c.Update()	
	Next 
EndFunction

Function RenderParticle() 
	Local c:TParticle
	For c=EachIn Particlelist
		c.Render()	
	Next 
EndFunction

Function UpdateBullet() 
	Local c:TBullet
	For c=EachIn Bulletlist
		c.Update()	
	Next 
EndFunction

Function RenderBullet() 
	Local c:TBullet
	For c=EachIn Bulletlist
		c.Render()	
	Next 
EndFunction

Function RenderFrames() 
	Local c:TFrame
	For c=EachIn Framelist
		c.Render(0,0)	
	Next 
EndFunction

Function RenderEnemy() 
	Local c:Vihu
	For c=EachIn Vihulist
		c.Render()	
	Next 
EndFunction

Function RenderPlayer() 
	Local c:TPlayer
	For c=EachIn Playerlist
		c.Render()	
	Next 
EndFunction

Function UpdateEnemy() 
Local c:Vihu
	For c = EachIn Vihulist
		If c.movingaway < 1.5 Then
			c.Update() 
		Else
			Vihulist.Remove(c)
		EndIf
	Next 
EndFunction

Function UpdatePlayer() 
Local c:TPlayer
	For c=EachIn Playerlist
		c.Update()
	Next 
EndFunction

Function UpdateFrames() 
Local c:TFrame
'everyone_stop = true
	For c = EachIn Framelist
		If c.life > 0 Then 
			c.Update( zoomin ) 
		Else
			Framelist.Remove(c) 
		EndIf
	Next 

EndFunction

Function distance(x1, y1, x2, y2) 
	Local distance
	distance = Sqr((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1)) 
	Return distance
End Function

Function getangle(x1 , y1 , x2 , y2) 
	Return ATan2( y1- y2 , x1-x2 ) + 180
EndFunction

Function Lerp: Double (t: Double, a: Double, b: Double)
	  Return a + t * (b - a)
EndFunction

Function PlaySoundBetter(sound:TSound,vol:Float)

	Local channel:TChannel
	Local volume:Float
	Local panvalue:Float
	
	volume = vol

	channel:TChannel = AllocChannel()				        ' allocate a channel

	'volume#   = (1 - ((GetDistance#(originx,originy,soundx,soundy) * (1 - volspread#)) / 100))
	'panvalue# = (2 * ((soundx / GraphicsWidth())) - 1)

	'	If panvalue# < -1 panvalue# = -1
	'	If panvalue# > 1 panvalue# = 1

	''SetChannelRate(channel:TChannel,Rnd(.8,1.2))				' make each sound original
	SetChannelVolume(channel:TChannel,volume#)
	'SetChannelPan(channel:TChannel,panvalue#)

		PlaySound(sound:TSound,channel:TChannel)	        ' play sound

End Function
